commit 4b10620c2215f449235e14ef45c28d8bd7aed720
Author: Andreas Kohlbecker <a.kohlbecker@bgbm.org>
Date:   Fri Feb 19 13:31:39 2016 +0100

    updating lauchers to java 8, harmonization, and fixing profiler setup

diff --git a/ide/eclipse/cdm-server - profile.launch b/ide/eclipse/cdm-server - profile.launch
index bc71f4a..fe45f3a 100644
--- a/ide/eclipse/cdm-server - profile.launch	
+++ b/ide/eclipse/cdm-server - profile.launch	
@@ -6,6 +6,9 @@
 <listAttribute key="org.eclipse.debug.core.MAPPED_RESOURCE_TYPES">
 <listEntry value="1"/>
 </listAttribute>
+<mapAttribute key="org.eclipse.debug.core.environmentVariables">
+<mapEntry key="LD_LIBRARY_PATH" value="/opt/libyjpagent"/>
+</mapAttribute>
 <stringAttribute key="org.eclipse.debug.core.source_locator_id" value="org.eclipse.jdt.launching.sourceLocator.JavaSourceLookupDirector"/>
 <stringAttribute key="org.eclipse.debug.core.source_locator_memento" value="&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot; standalone=&quot;no&quot;?&gt;&#10;&lt;sourceLookupDirector&gt;&#10;&lt;sourceContainers duplicates=&quot;false&quot;&gt;&#10;&lt;container memento=&quot;&amp;lt;?xml version=&amp;quot;1.0&amp;quot; encoding=&amp;quot;UTF-8&amp;quot; standalone=&amp;quot;no&amp;quot;?&amp;gt;&amp;#10;&amp;lt;archive detectRoot=&amp;quot;true&amp;quot; path=&amp;quot;/home/andreas/.m2/repository/net/sf/ehcache/ehcache/1.2.3/ehcache-1.2.3&amp;quot;/&amp;gt;&amp;#10;&quot; typeId=&quot;org.eclipse.debug.core.containerType.externalArchive&quot;/&gt;&#10;&lt;container memento=&quot;&amp;lt;?xml version=&amp;quot;1.0&amp;quot; encoding=&amp;quot;UTF-8&amp;quot; standalone=&amp;quot;no&amp;quot;?&amp;gt;&amp;#10;&amp;lt;javaProject name=&amp;quot;cdmlib-remote-webapp&amp;quot;/&amp;gt;&amp;#10;&quot; typeId=&quot;org.eclipse.jdt.launching.sourceContainer.javaProject&quot;/&gt;&#10;&lt;container memento=&quot;&amp;lt;?xml version=&amp;quot;1.0&amp;quot; encoding=&amp;quot;UTF-8&amp;quot; standalone=&amp;quot;no&amp;quot;?&amp;gt;&amp;#10;&amp;lt;javaProject name=&amp;quot;cdmlib-remote&amp;quot;/&amp;gt;&amp;#10;&quot; typeId=&quot;org.eclipse.jdt.launching.sourceContainer.javaProject&quot;/&gt;&#10;&lt;container memento=&quot;&amp;lt;?xml version=&amp;quot;1.0&amp;quot; encoding=&amp;quot;UTF-8&amp;quot; standalone=&amp;quot;no&amp;quot;?&amp;gt;&amp;#10;&amp;lt;javaProject name=&amp;quot;cdmlib-commons&amp;quot;/&amp;gt;&amp;#10;&quot; typeId=&quot;org.eclipse.jdt.launching.sourceContainer.javaProject&quot;/&gt;&#10;&lt;container memento=&quot;&amp;lt;?xml version=&amp;quot;1.0&amp;quot; encoding=&amp;quot;UTF-8&amp;quot; standalone=&amp;quot;no&amp;quot;?&amp;gt;&amp;#10;&amp;lt;javaProject name=&amp;quot;cdmlib-ext&amp;quot;/&amp;gt;&amp;#10;&quot; typeId=&quot;org.eclipse.jdt.launching.sourceContainer.javaProject&quot;/&gt;&#10;&lt;container memento=&quot;&amp;lt;?xml version=&amp;quot;1.0&amp;quot; encoding=&amp;quot;UTF-8&amp;quot; standalone=&amp;quot;no&amp;quot;?&amp;gt;&amp;#10;&amp;lt;javaProject name=&amp;quot;cdmlib-model&amp;quot;/&amp;gt;&amp;#10;&quot; typeId=&quot;org.eclipse.jdt.launching.sourceContainer.javaProject&quot;/&gt;&#10;&lt;container memento=&quot;&amp;lt;?xml version=&amp;quot;1.0&amp;quot; encoding=&amp;quot;UTF-8&amp;quot; standalone=&amp;quot;no&amp;quot;?&amp;gt;&amp;#10;&amp;lt;javaProject name=&amp;quot;cdmlib-persistence&amp;quot;/&amp;gt;&amp;#10;&quot; typeId=&quot;org.eclipse.jdt.launching.sourceContainer.javaProject&quot;/&gt;&#10;&lt;container memento=&quot;&amp;lt;?xml version=&amp;quot;1.0&amp;quot; encoding=&amp;quot;UTF-8&amp;quot; standalone=&amp;quot;no&amp;quot;?&amp;gt;&amp;#10;&amp;lt;javaProject name=&amp;quot;cdmlib-services&amp;quot;/&amp;gt;&amp;#10;&quot; typeId=&quot;org.eclipse.jdt.launching.sourceContainer.javaProject&quot;/&gt;&#10;&lt;container memento=&quot;&amp;lt;?xml version=&amp;quot;1.0&amp;quot; encoding=&amp;quot;UTF-8&amp;quot; standalone=&amp;quot;no&amp;quot;?&amp;gt;&amp;#10;&amp;lt;javaProject name=&amp;quot;cdmlib-io&amp;quot;/&amp;gt;&amp;#10;&quot; typeId=&quot;org.eclipse.jdt.launching.sourceContainer.javaProject&quot;/&gt;&#10;&lt;container memento=&quot;&amp;lt;?xml version=&amp;quot;1.0&amp;quot; encoding=&amp;quot;UTF-8&amp;quot; standalone=&amp;quot;no&amp;quot;?&amp;gt;&amp;#10;&amp;lt;default/&amp;gt;&amp;#10;&quot; typeId=&quot;org.eclipse.debug.core.containerType.default&quot;/&gt;&#10;&lt;/sourceContainers&gt;&#10;&lt;/sourceLookupDirector&gt;&#10;"/>
 <listAttribute key="org.eclipse.debug.ui.favoriteGroups">
@@ -14,8 +17,8 @@
 </listAttribute>
 <stringAttribute key="org.eclipse.jdt.launching.CLASSPATH_PROVIDER" value="org.eclipse.m2e.launchconfig.classpathProvider"/>
 <stringAttribute key="org.eclipse.jdt.launching.MAIN_TYPE" value="eu.etaxonomy.cdm.server.Bootloader"/>
-<stringAttribute key="org.eclipse.jdt.launching.PROGRAM_ARGUMENTS" value="-webapp=${workspace_loc:cdmlib-remote-webapp/src/main/webapp/}&#10;-webappClasspath=${project_classpath:cdmlib-remote-webapp}&#10;-datasources=${system_property:user.home}/.cdmLibrary/datasources-cdm-server.xml&#10;-contextPathPrefix=&quot;/cdmserver&quot;&#13;&#10;-jmx"/>
+<stringAttribute key="org.eclipse.jdt.launching.PROGRAM_ARGUMENTS" value="-webapp=${workspace_loc:cdmlib-remote-webapp/src/main/webapp/}&#10;-webappClasspath=${project_classpath:cdmlib-remote-webapp}&#10;-datasources=${system_property:user.home}/.cdmLibrary/datasources-cdm-server.xml&#10;-contextPathPrefix=&quot;/cdmserver&quot;&#10;-forceSchemaUpdate&#13;&#10;-jmx"/>
 <stringAttribute key="org.eclipse.jdt.launching.PROJECT_ATTR" value="cdm-server"/>
 <stringAttribute key="org.eclipse.jdt.launching.SOURCE_PATH_PROVIDER" value="org.eclipse.m2e.launchconfig.sourcepathProvider"/>
-<stringAttribute key="org.eclipse.jdt.launching.VM_ARGUMENTS" value="-Xmx1200M&#13;&#10;&#13;&#10;-XX:+UseG1GC&#10;&#13;&#10;-Dorg.eclipse.jetty.util.log.DEBUG=false&#10;-Dlog4j.configuration=file:///${system_property:user.home}/.cdmLibrary/log4j.properties&#13;&#10;&#13;&#10;-Dcom.sun.management.jmxremote.ssl=false&#13;&#10;-Dcom.sun.management.jmxremote.authenticate=false&#13;&#10;-Dcom.sun.management.jmxremote.port=9999&#10;&#10;-XX:-UseSplitVerifier &#10;-agentlib:yjpagent"/>
+<stringAttribute key="org.eclipse.jdt.launching.VM_ARGUMENTS" value="-Xmx1200M&#10;-Xms1200M&#13;&#10;&#13;&#10;-XX:MinHeapFreeRatio=25&#10;-XX:+UseG1GC&#10;&#10;-Dspring.profiles.active=remoting&#10;&#13;&#10;-Dorg.eclipse.jetty.util.log.DEBUG=false&#10;-Dlog4j.configuration=file:///${system_property:user.home}/.cdmLibrary/log4j.properties&#13;&#10;&#13;&#10;-Dcom.sun.management.jmxremote.ssl=false&#13;&#10;-Dcom.sun.management.jmxremote.authenticate=false&#13;&#10;-Dcom.sun.management.jmxremote.port=9999&#10;&#10;-agentlib:yjpagent"/>
 </launchConfiguration>
diff --git a/ide/eclipse/cdm-server - start from war.launch b/ide/eclipse/cdm-server - start from war.launch
index e62167d..07b123e 100644
--- a/ide/eclipse/cdm-server - start from war.launch	
+++ b/ide/eclipse/cdm-server - start from war.launch	
@@ -17,5 +17,5 @@
 <stringAttribute key="org.eclipse.jdt.launching.PROGRAM_ARGUMENTS" value="-datasources=${system_property:user.home}/.cdmLibrary/datasources-cdm-server.xml&#10;-contextPathPrefix=&quot;/cdmserver&quot;&#10;-forceSchemaUpdate&#13;&#10;-jmx"/>
 <stringAttribute key="org.eclipse.jdt.launching.PROJECT_ATTR" value="cdm-server"/>
 <stringAttribute key="org.eclipse.jdt.launching.SOURCE_PATH_PROVIDER" value="org.eclipse.m2e.launchconfig.sourcepathProvider"/>
-<stringAttribute key="org.eclipse.jdt.launching.VM_ARGUMENTS" value="-Xmx1200M&#13;&#10;&#13;&#10;-XX:+UseG1GC&#13;&#10;&#10;-Dspring.profiles.active=remoting&#13;&#10;-Dorg.eclipse.jetty.util.log.DEBUG=false&#10;-Dlog4j.configuration=file:///${system_property:user.home}/.cdmLibrary/log4j.properties&#13;&#10;&#13;&#10;-Dcom.sun.management.jmxremote.ssl=false&#13;&#10;-Dcom.sun.management.jmxremote.authenticate=false&#13;&#10;-Dcom.sun.management.jmxremote.port=9999"/>
+<stringAttribute key="org.eclipse.jdt.launching.VM_ARGUMENTS" value="-Xmx1200M&#13;&#10;-Xms1200M&#10;&#13;&#10;-XX:MinHeapFreeRatio=25&#10;-XX:+UseG1GC&#13;&#10;&#10;-Dspring.profiles.active=remoting&#10;&#13;&#10;-Dorg.eclipse.jetty.util.log.DEBUG=false&#10;-Dlog4j.configuration=file:///${system_property:user.home}/.cdmLibrary/log4j.properties&#13;&#10;&#13;&#10;-Dcom.sun.management.jmxremote.ssl=false&#13;&#10;-Dcom.sun.management.jmxremote.authenticate=false&#13;&#10;-Dcom.sun.management.jmxremote.port=9999"/>
 </launchConfiguration>
diff --git a/ide/eclipse/cdm-server - start.launch b/ide/eclipse/cdm-server - start.launch
index 09a03be..9583cc1 100644
--- a/ide/eclipse/cdm-server - start.launch	
+++ b/ide/eclipse/cdm-server - start.launch	
@@ -13,9 +13,10 @@
 <listEntry value="org.eclipse.debug.ui.launchGroup.run"/>
 </listAttribute>
 <stringAttribute key="org.eclipse.jdt.launching.CLASSPATH_PROVIDER" value="org.eclipse.m2e.launchconfig.classpathProvider"/>
+<stringAttribute key="org.eclipse.jdt.launching.JRE_CONTAINER" value="org.eclipse.jdt.launching.JRE_CONTAINER/org.eclipse.jdt.internal.debug.ui.launcher.StandardVMType/jdk1.8.0_60"/>
 <stringAttribute key="org.eclipse.jdt.launching.MAIN_TYPE" value="eu.etaxonomy.cdm.server.Bootloader"/>
 <stringAttribute key="org.eclipse.jdt.launching.PROGRAM_ARGUMENTS" value="-webapp=${workspace_loc:cdmlib-remote-webapp/src/main/webapp/}&#10;-webappClasspath=${project_classpath:cdmlib-remote-webapp}&#10;-datasources=${system_property:user.home}/.cdmLibrary/datasources-cdm-server.xml&#10;-contextPathPrefix=&quot;/cdmserver&quot;&#10;-forceSchemaUpdate&#13;&#10;-jmx"/>
 <stringAttribute key="org.eclipse.jdt.launching.PROJECT_ATTR" value="cdm-server"/>
 <stringAttribute key="org.eclipse.jdt.launching.SOURCE_PATH_PROVIDER" value="org.eclipse.m2e.launchconfig.sourcepathProvider"/>
-<stringAttribute key="org.eclipse.jdt.launching.VM_ARGUMENTS" value="-Xmx1200M&#10;&#13;&#10;-XX:+UseG1GC&#13;&#10;&#10;-Dspring.profiles.active=remoting&#13;&#10;-Dorg.eclipse.jetty.util.log.DEBUG=false&#10;-Dlog4j.configuration=file:///${system_property:user.home}/.cdmLibrary/log4j.properties&#13;&#10;&#13;&#10;-Dcom.sun.management.jmxremote.ssl=false&#13;&#10;-Dcom.sun.management.jmxremote.authenticate=false&#13;&#10;-Dcom.sun.management.jmxremote.port=9999"/>
+<stringAttribute key="org.eclipse.jdt.launching.VM_ARGUMENTS" value="-Xmx1200M&#10;-Xms1200M&#10;&#10;-XX:MinHeapFreeRatio=25&#10;-XX:+UseG1GC&#13;&#10;&#10;-Dspring.profiles.active=remoting&#10;&#13;&#10;-Dorg.eclipse.jetty.util.log.DEBUG=false&#10;-Dlog4j.configuration=file:///${system_property:user.home}/.cdmLibrary/log4j.properties&#13;&#10;&#13;&#10;-Dcom.sun.management.jmxremote.ssl=false&#13;&#10;-Dcom.sun.management.jmxremote.authenticate=false&#13;&#10;-Dcom.sun.management.jmxremote.port=9999"/>
 </launchConfiguration>