commit 0d21320d98a5a22ab044496dadbcd24ec854fdf3
Author: Andreas Müller <a.mueller@bgbm.org>
Date:   Tue Apr 10 10:12:44 2012 +0000

    deleting some old sources

diff --git a/.gitattributes b/.gitattributes
index a4c042fd..66f641a9 100644
--- a/.gitattributes
+++ b/.gitattributes
@@ -61,7 +61,7 @@ app-import/src/main/java/eu/etaxonomy/cdm/app/sdd/ViolaActivator.java -text
 app-import/src/main/java/eu/etaxonomy/cdm/app/sdd/ViolaExportActivator.java -text
 app-import/src/main/java/eu/etaxonomy/cdm/app/sdd/ViolaUpdateActivator.java -text
 app-import/src/main/java/eu/etaxonomy/cdm/app/sdd/applicationContext.xml -text
-app-import/src/main/java/eu/etaxonomy/cdm/app/synthesysImport/SpecimenImport.java -text
+app-import/src/main/java/eu/etaxonomy/cdm/app/synthesysImport/SpecimenImportActivator.java -text
 app-import/src/main/java/eu/etaxonomy/cdm/app/synthesysImport/SynthesysCacheActivator.java -text
 app-import/src/main/java/eu/etaxonomy/cdm/app/synthesysImport/SynthesysSpecimenTestActivator.java -text
 app-import/src/main/java/eu/etaxonomy/cdm/app/tcs/TcsRdfTestActivator.java -text
diff --git a/app-import/src/main/java/eu/etaxonomy/cdm/app/abcdImport/SynthesysCacheActivator.java b/app-import/src/main/java/eu/etaxonomy/cdm/app/abcdImport/SynthesysCacheActivator.java
index 5abf9930..4de203b9 100644
--- a/app-import/src/main/java/eu/etaxonomy/cdm/app/abcdImport/SynthesysCacheActivator.java
+++ b/app-import/src/main/java/eu/etaxonomy/cdm/app/abcdImport/SynthesysCacheActivator.java
@@ -205,7 +205,7 @@ public class SynthesysCacheActivator {
 		TransactionStatus tx = null;
 
 
-		app = CdmApplicationController.NewInstance(CdmDestinations.cdm_test_patricia(), hbm2dll);
+		app = CdmApplicationController.NewInstance(CdmDestinations.localH2(), hbm2dll);
 		
 		tx = app.startTransaction();
 		try {
diff --git a/app-import/src/main/java/eu/etaxonomy/cdm/app/common/CdmDestinations.java b/app-import/src/main/java/eu/etaxonomy/cdm/app/common/CdmDestinations.java
index cf8dbe88..909f5eb3 100644
--- a/app-import/src/main/java/eu/etaxonomy/cdm/app/common/CdmDestinations.java
+++ b/app-import/src/main/java/eu/etaxonomy/cdm/app/common/CdmDestinations.java
@@ -51,38 +51,6 @@ public class CdmDestinations {
 		return makeDestination(dbType, cdmServer, cdmDB, -1, cdmUserName, null);
 	}
 	
-	public static ICdmDataSource cdm_test_jaxb(){
-		DatabaseTypeEnum dbType = DatabaseTypeEnum.MySQL;
-		String cdmServer = "192.168.2.10";
-		String cdmDB = "cdm_test_jaxb"; 
-		String cdmUserName = "edit";
-		return makeDestination(dbType, cdmServer, cdmDB, -1, cdmUserName, null);
-	}
-	
-	public static ICdmDataSource cdm_test_jaxb2(){
-		DatabaseTypeEnum dbType = DatabaseTypeEnum.MySQL;
-		String cdmServer = "192.168.2.10";
-		String cdmDB = "cdm_test_jaxb2"; 
-		String cdmUserName = "edit";
-		return makeDestination(dbType, cdmServer, cdmDB, -1, cdmUserName, null);
-	}
-
-	public static ICdmDataSource cdm_test_andreasM(){
-		DatabaseTypeEnum dbType = DatabaseTypeEnum.MySQL;
-		String cdmServer = "192.168.2.10";
-		String cdmDB = "cdm_test_andreasM"; 
-		String cdmUserName = "edit";
-		return makeDestination(dbType, cdmServer, cdmDB, -1, cdmUserName, null);
-	}
-	
-	public static ICdmDataSource cdm_test_andreasM2(){
-		DatabaseTypeEnum dbType = DatabaseTypeEnum.MySQL;
-		String cdmServer = "192.168.2.10";
-		String cdmDB = "cdm_test_andreasM2"; 
-		String cdmUserName = "edit";
-		return makeDestination(dbType, cdmServer, cdmDB, -1, cdmUserName, null);
-	}
-	
 	public static ICdmDataSource cdm_test_local_mysql(){
 		DatabaseTypeEnum dbType = DatabaseTypeEnum.MySQL;
 		String cdmServer = "127.0.0.1";
@@ -148,24 +116,6 @@ public class CdmDestinations {
 		String cdmUserName = "edit";
 		return makeDestination(dbType, cdmServer, cdmDB, -1, cdmUserName, null);
 	}
-	
-	public static ICdmDataSource cdm_test_patricia(){
-		DatabaseTypeEnum dbType = DatabaseTypeEnum.MySQL;
-		String cdmServer = "192.168.2.10";
-		String cdmDB = "cdm_test_patricia";
-		String cdmUserName = "edit";
-		return makeDestination(dbType, cdmServer, cdmDB, -1, cdmUserName, null);
-	}
-	
-	//
-	public static ICdmDataSource cdm_test_andreasK1(){
-		DatabaseTypeEnum dbType = DatabaseTypeEnum.MySQL;
-		String cdmServer = "192.168.2.10";
-		String cdmDB = "cdm_test_andreasK1";
-		String cdmUserName = "edit";
-		return makeDestination(dbType, cdmServer, cdmDB, -1, cdmUserName, null);
-	}
-	
 
 	public static ICdmDataSource cdm_pesi_erms(){
 		DatabaseTypeEnum dbType = DatabaseTypeEnum.MySQL;
@@ -174,14 +124,7 @@ public class CdmDestinations {
 		String cdmUserName = "edit";
 		return makeDestination(dbType, cdmServer, cdmDB, -1, cdmUserName, null);
 	}
-	
-	public static ICdmDataSource cdm_campanulaceae(){
-		DatabaseTypeEnum dbType = DatabaseTypeEnum.MySQL;
-		String cdmServer = "192.168.2.10";
-		String cdmDB = "cdm_campanulaceae";
-		String cdmUserName = "edit";
-		return makeDestination(dbType, cdmServer, cdmDB, -1, cdmUserName, null);
-	}
+
 
 	public static ICdmDataSource cdm_ildis_dev(){
 		DatabaseTypeEnum dbType = DatabaseTypeEnum.MySQL;
diff --git a/app-import/src/main/java/eu/etaxonomy/cdm/app/dwca/DwcaImportActivator.java b/app-import/src/main/java/eu/etaxonomy/cdm/app/dwca/DwcaImportActivator.java
index 89aa2a0c..556626e8 100644
--- a/app-import/src/main/java/eu/etaxonomy/cdm/app/dwca/DwcaImportActivator.java
+++ b/app-import/src/main/java/eu/etaxonomy/cdm/app/dwca/DwcaImportActivator.java
@@ -41,14 +41,14 @@ public class DwcaImportActivator {
 	static DbSchemaValidation hbm2dll = DbSchemaValidation.CREATE;
 //	static final URI source = dwca_test_in();
 //	static final URI source = dwca_test_cich_len();
-//	static final URI source = dwca_test_col_cichorium();
+	static final URI source = dwca_test_col_cichorium();
 //	static final URI source = dwca_test_col_All();
-	static final URI source = dwca_test_col_All_Pesi2();
+//	static final URI source = dwca_test_col_All_Pesi2();
 	
 	
 //	static final ICdmDataSource cdmDestination = CdmDestinations.localH2();
-	static final ICdmDataSource cdmDestination = CdmDestinations.cdm_test_local_mysql_pesi_test();
-//	static final ICdmDataSource cdmDestination = CdmDestinations.cdm_test_local_mysql_test();
+//	static final ICdmDataSource cdmDestination = CdmDestinations.cdm_test_local_mysql_pesi_test();
+	static final ICdmDataSource cdmDestination = CdmDestinations.cdm_test_local_mysql_test();
 
 	
 	//classification
@@ -64,6 +64,8 @@ public class DwcaImportActivator {
 	//config
 	static DatasetUse datasetUse = DatasetUse.SECUNDUM;
 	static boolean scientificNameIdAsOriginalSourceId = true;
+	static boolean guessNomRef = true;
+	private boolean handleAllRefsAsCitation = true;
 	
 	//validate
 	static boolean validateRankConsistency = false;
@@ -88,9 +90,13 @@ public class DwcaImportActivator {
 		config.setCheck(check);
 		config.setDbSchemaValidation(hbm2dll);
 		config.setMappingType(mappingType);
+		
 		config.setScientificNameIdAsOriginalSourceId(scientificNameIdAsOriginalSourceId);
 		config.setValidateRankConsistency(validateRankConsistency);
 		config.setNomenclaturalCode(defaultNomCode);
+		config.setDatasetUse(datasetUse);
+		config.setGuessNomenclaturalReferences(guessNomRef);
+		config.setHandleAllRefsAsCitation(handleAllRefsAsCitation);
 		
 		CdmDefaultImport myImport = new CdmDefaultImport();
 
diff --git a/app-import/src/main/java/eu/etaxonomy/cdm/app/jaxb/CdmDiffActivator.java b/app-import/src/main/java/eu/etaxonomy/cdm/app/jaxb/CdmDiffActivator.java
index 7a50b09a..7cc3756f 100644
--- a/app-import/src/main/java/eu/etaxonomy/cdm/app/jaxb/CdmDiffActivator.java
+++ b/app-import/src/main/java/eu/etaxonomy/cdm/app/jaxb/CdmDiffActivator.java
@@ -28,7 +28,7 @@ public class CdmDiffActivator {
 
 	static DbSchemaValidation hbm2dll = DbSchemaValidation.CREATE;
 
-	static final ICdmDataSource cdmSourceOne = CdmDestinations.cdm_test_jaxb();
-	static final ICdmDataSource cdmSourceTwo = CdmDestinations.cdm_test_jaxb2();
+	static final ICdmDataSource cdmSourceOne = CdmDestinations.localH2();
+	static final ICdmDataSource cdmSourceTwo = CdmDestinations.localH2();
 
 }
diff --git a/app-import/src/main/java/eu/etaxonomy/cdm/app/jaxb/JaxbImportActivator.java b/app-import/src/main/java/eu/etaxonomy/cdm/app/jaxb/JaxbImportActivator.java
index 54543b73..e86fe51c 100644
--- a/app-import/src/main/java/eu/etaxonomy/cdm/app/jaxb/JaxbImportActivator.java
+++ b/app-import/src/main/java/eu/etaxonomy/cdm/app/jaxb/JaxbImportActivator.java
@@ -36,7 +36,7 @@ public class JaxbImportActivator {
 
 	/* SerializeFrom DB **/
 	//private static final ICdmDataSource cdmSource = CdmDestinations.localH2Diptera();
-	private static final ICdmDataSource cdmDestination = CdmDestinations.cdm_test_jaxb();
+	private static final ICdmDataSource cdmDestination = CdmDestinations.localH2();
 	
 	// Import:
 	private static String importFileNameString = 
diff --git a/app-import/src/main/java/eu/etaxonomy/cdm/app/synthesysImport/SpecimenImport.java b/app-import/src/main/java/eu/etaxonomy/cdm/app/synthesysImport/SpecimenImport.java
deleted file mode 100644
index f9161ece..00000000
--- a/app-import/src/main/java/eu/etaxonomy/cdm/app/synthesysImport/SpecimenImport.java
+++ /dev/null
@@ -1,69 +0,0 @@
-/**
- * Copyright (C) 2007 EDIT
- * European Distributed Institute of Taxonomy 
- * http://www.e-taxonomy.eu
- * 
- * The contents of this file are subject to the Mozilla Public License Version 1.1
- * See LICENSE.TXT at the top of this package for the full license terms.
- */
-
-package eu.etaxonomy.cdm.app.synthesysImport;
-import java.net.URI;
-import java.net.URISyntaxException;
-
-import org.apache.log4j.Logger;
-
-import eu.etaxonomy.cdm.app.common.CdmDestinations;
-import eu.etaxonomy.cdm.database.DbSchemaValidation;
-import eu.etaxonomy.cdm.database.ICdmDataSource;
-import eu.etaxonomy.cdm.io.common.CdmDefaultImport;
-import eu.etaxonomy.cdm.io.common.IImportConfigurator.CHECK;
-import eu.etaxonomy.cdm.io.specimen.excel.in.SpecimenSynthesysExcelImportConfigurator;
-
-public class SpecimenImport {
-private static Logger logger = Logger.getLogger(SpecimenImport.class);
-	
-	//database validation status (create, update, validate ...)
-	static DbSchemaValidation hbm2dll = DbSchemaValidation.CREATE;
-	final static String excelSource = "/home/patricia/Desktop/CDMtabular6493890c4d_18_11_08.xls";
-//	final static String xmlSource = "C:\\localCopy\\eclipse\\cdmlib\\app-import\\src\\main\\resources\\specimenABCD\\CDMtabular9c04a474e2_23_09_08.xls";	
-	
-	
-	static final ICdmDataSource cdmDestination = CdmDestinations.cdm_test_patricia();
-	//check - import
-	static final CHECK check = CHECK.IMPORT_WITHOUT_CHECK;
-	
-	/**
-	 * @param args
-	 */
-	public static void main(String[] args) {
-		URI source;
-		try {
-			source = new URI(excelSource);
-			System.out.println(source);
-			System.out.println("Start import from  Synthesys Specimen data("+ source.toString() + ") ...");
-			
-			ICdmDataSource destination = cdmDestination;
-			SpecimenSynthesysExcelImportConfigurator specimenImportConfigurator = SpecimenSynthesysExcelImportConfigurator.NewInstance(source,  destination);
-			
-			specimenImportConfigurator.setSourceSecId("specimen");
-			specimenImportConfigurator.setCheck(check);
-			specimenImportConfigurator.setDbSchemaValidation(hbm2dll);
-			specimenImportConfigurator.setDoAutomaticParsing(true);
-			specimenImportConfigurator.setReUseExistingMetadata(true);
-			specimenImportConfigurator.setReUseTaxon(true);
-			specimenImportConfigurator.setSourceReference(null);
-			specimenImportConfigurator.setTaxonReference(null);
-			
-			// invoke import
-			CdmDefaultImport<SpecimenSynthesysExcelImportConfigurator> specimenImport = new CdmDefaultImport<SpecimenSynthesysExcelImportConfigurator>();
-			//new Test().invoke(tcsImportConfigurator);
-			specimenImport.invoke(specimenImportConfigurator);
-			System.out.println("End import from SpecimenData ("+ source.toString() + ")...");
-		} catch (URISyntaxException e) {
-			e.printStackTrace();
-		}
-		
-	}
-
-}
diff --git a/app-import/src/main/java/eu/etaxonomy/cdm/app/synthesysImport/SpecimenImportActivator.java b/app-import/src/main/java/eu/etaxonomy/cdm/app/synthesysImport/SpecimenImportActivator.java
new file mode 100644
index 00000000..cfbb1952
--- /dev/null
+++ b/app-import/src/main/java/eu/etaxonomy/cdm/app/synthesysImport/SpecimenImportActivator.java
@@ -0,0 +1,70 @@
+/**
+ * Copyright (C) 2007 EDIT
+ * European Distributed Institute of Taxonomy 
+ * http://www.e-taxonomy.eu
+ * 
+ * The contents of this file are subject to the Mozilla Public License Version 1.1
+ * See LICENSE.TXT at the top of this package for the full license terms.
+ */
+
+package eu.etaxonomy.cdm.app.synthesysImport;
+import java.net.URI;
+import java.net.URISyntaxException;
+
+import org.apache.log4j.Logger;
+
+import eu.etaxonomy.cdm.app.common.CdmDestinations;
+import eu.etaxonomy.cdm.database.DbSchemaValidation;
+import eu.etaxonomy.cdm.database.ICdmDataSource;
+import eu.etaxonomy.cdm.io.common.CdmDefaultImport;
+import eu.etaxonomy.cdm.io.common.IImportConfigurator.CHECK;
+import eu.etaxonomy.cdm.io.specimen.excel.in.SpecimenSynthesysExcelImportConfigurator;
+
+public class SpecimenImportActivator {
+	@SuppressWarnings("unused")
+	private static Logger logger = Logger.getLogger(SpecimenImportActivator.class);
+	
+	//database validation status (create, update, validate ...)
+	static DbSchemaValidation hbm2dll = DbSchemaValidation.CREATE;
+	final static String excelSource = "/home/patricia/Desktop/CDMtabular6493890c4d_18_11_08.xls";
+//	final static String xmlSource = "C:\\localCopy\\eclipse\\cdmlib\\app-import\\src\\main\\resources\\specimenABCD\\CDMtabular9c04a474e2_23_09_08.xls";	
+	
+	
+	static final ICdmDataSource cdmDestination = CdmDestinations.localH2();
+	//check - import
+	static final CHECK check = CHECK.IMPORT_WITHOUT_CHECK;
+	
+	/**
+	 * @param args
+	 */
+	public static void main(String[] args) {
+		URI source;
+		try {
+			source = new URI(excelSource);
+			System.out.println(source);
+			System.out.println("Start import from  Synthesys Specimen data("+ source.toString() + ") ...");
+			
+			ICdmDataSource destination = cdmDestination;
+			SpecimenSynthesysExcelImportConfigurator specimenImportConfigurator = SpecimenSynthesysExcelImportConfigurator.NewInstance(source,  destination);
+			
+			specimenImportConfigurator.setSourceSecId("specimen");
+			specimenImportConfigurator.setCheck(check);
+			specimenImportConfigurator.setDbSchemaValidation(hbm2dll);
+			specimenImportConfigurator.setDoAutomaticParsing(true);
+			specimenImportConfigurator.setReUseExistingMetadata(true);
+			specimenImportConfigurator.setReUseTaxon(true);
+			specimenImportConfigurator.setSourceReference(null);
+			specimenImportConfigurator.setTaxonReference(null);
+			
+			// invoke import
+			CdmDefaultImport<SpecimenSynthesysExcelImportConfigurator> specimenImport = new CdmDefaultImport<SpecimenSynthesysExcelImportConfigurator>();
+			//new Test().invoke(tcsImportConfigurator);
+			specimenImport.invoke(specimenImportConfigurator);
+			System.out.println("End import from SpecimenData ("+ source.toString() + ")...");
+		} catch (URISyntaxException e) {
+			e.printStackTrace();
+		}
+		
+	}
+
+}
diff --git a/app-import/src/main/java/eu/etaxonomy/cdm/app/viennaImport/ViennaActivator.java b/app-import/src/main/java/eu/etaxonomy/cdm/app/viennaImport/ViennaActivator.java
index 3721efd7..902da307 100644
--- a/app-import/src/main/java/eu/etaxonomy/cdm/app/viennaImport/ViennaActivator.java
+++ b/app-import/src/main/java/eu/etaxonomy/cdm/app/viennaImport/ViennaActivator.java
@@ -66,7 +66,7 @@ public class ViennaActivator {
 		
 		try {
 			if (withCdm){
-				app = CdmApplicationController.NewInstance(CdmDestinations.cdm_test_patricia());
+				app = CdmApplicationController.NewInstance(CdmDestinations.localH2());
 			}else{
 				//app = CdmApplicationController.NewInstance(DbSchemaValidation.VALIDATE);
 			}